#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h> 
#include <X11/cursorfont.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Simple.h>

#define MAXDESCSIZE   32                /* Max # of polys in 1 desc */
#define MAXPOINTPOLY  32                /* Max # of points in a poly */
#define MAXUNDOS      11 		/* Max # of undo's + 1 */
#define TRUE  1
#define FALSE 0
#define XOR   1
#define COPY  2
#define WIDTH         765
#define HEIGHT        510

Display *dpy;

typedef struct {
  int size;
  int color;
  XPoint points[MAXPOINTPOLY];
} polygon;

typedef struct {
  int cPoly;
  polygon pic[MAXDESCSIZE];
} scene;

typedef struct {
  int numundos;
  int picpointer;
  scene pastpic[MAXUNDOS];
} undoData;

typedef struct {
    int start_x, start_y, last_x, last_y;
    int start_poly_x, start_poly_y;
    int doingPoly;
    int doingRect;
    int doingElipse;
    int doingMove;
    int doingCopy;
    int doingPointAdjust;
    GC  dashGc;
    GC  solidXorGc;
    GC  solidGc;
    polygon pic[MAXDESCSIZE];        /* Actual picture */
    undoData undo;
    int cPoly;
    int cPrimitive;
} drawData;
