#include <math.h>
#include "draw.h"

#define PI     3.14159265358979323846

extern drawData  data;
extern int       cColor;

ElipseToPoly(x, y, width, height)
int x, y, width, height;
{
   int i, center_x, center_y;
   double step, angle, s, c;

   angle = 0;
   step = 2 * PI / MAXPOINTPOLY;
   center_x = x + width/2;
   center_y = y + height/2;
   for (i = 0; i < MAXPOINTPOLY; i++) {
      s = sin(angle);
      c = cos(angle);
      data.pic[data.cPoly].points[i].x = center_x+(width/2)*c;
      data.pic[data.cPoly].points[i].y = center_y+(height/2)*s;
      angle += step;
   }
   data.pic[data.cPoly].size = MAXPOINTPOLY;
}

void StartElipse(w, event)
Widget  w;
XEvent  *event;
{
   int diff_x, diff_y;
   int cPnt;

   if (data.cPoly != MAXDESCSIZE) {
      SetGCColor(w, data.dashGc, XOR);
      SetGCColor(w, data.solidXorGc, XOR);
      SetGCColor(w, data.solidGc, COPY);

      data.pic[data.cPoly].color = cColor;
      cPnt = data.pic[data.cPoly].size = 0;
      data.doingElipse = TRUE;
      data.last_x  =  data.start_x = event->xbutton.x;
      data.last_y  =  data.start_y = event->xbutton.y;
      data.pic[data.cPoly].points[cPnt].x = data.start_poly_x  =  data.start_x;
      data.pic[data.cPoly].points[cPnt].y = data.start_poly_y  =  data.start_y;
      data.pic[data.cPoly].size++; 

      XDrawArc(XtDisplay(w), XtWindow(w), data.dashGc, 
               data.start_x,data.start_y, 
               data.last_x-data.start_x, data.last_y-data.start_y,
	       0, 360*64); 
      GrabPointer(); 
   }
}

void MoveElipse(w, event)
Widget  w;
XEvent  *event;
{
   int diff_x, diff_y;

   /* Draw once to clear the previous elipse. */
   XDrawArc(XtDisplay(w), XtWindow(w), data.dashGc, 
            data.start_x,data.start_y, 
            data.last_x-data.start_x, data.last_y-data.start_y,
	    0, 360*64); 

   /* Update the endpoints. */
   data.last_x  =  event->xbutton.x;
   data.last_y  =  event->xbutton.y;

   if (data.last_x < data.start_x) 
      data.last_x = data.start_x;
   if (data.last_y < data.start_y) 
      data.last_y = data.start_y;

   /* Draw the new elipse */
   XDrawArc(XtDisplay(w), XtWindow(w), data.dashGc, 
            data.start_x, data.start_y, 
            data.last_x-data.start_x, data.last_y-data.start_y,
            0, 360*64);  
}


void UpdateElipse(w, event)
Widget     w;
XEvent     *event;
{
   int cPnt;

   if (ValidButtonPress(event)) {
      /* Clear the current line and update the endpoint info.  */
      XDrawArc(XtDisplay(w), XtWindow(w), data.dashGc, 
               data.start_x, data.start_y, 
               data.last_x-data.start_x, data.last_y-data.start_y,
	       0, 360*64);

      data.doingElipse = FALSE;
      ElipseToPoly(data.start_x, data.start_y,
		   data.last_x-data.start_x, data.last_y-data.start_y);
      DrawPoly(data.cPoly);

      data.cPoly++;
      UpdateUndo();
      SetPolyNumLabel();
      UngrabPointer(); 
   } 
}
