#include "draw.h"

extern drawData  data;

int pick, oldx, oldy;

int cutting(x1,y1,x2,y2,xp,yp)
int x1,y1,x2,y2,xp,yp;
{
  int cutting;
  int xs;

  if (((y1 < yp) && (y2 < yp)) || ((y1 > yp) && (y2 > yp)) )
    cutting = 0;
  else 
    if (y1==y2) 
       cutting = 0;
    else {
       xs = x1+((float)(yp-y1)/(float)(y2-y1))*(x2-x1); 
       cutting = (xs > xp);
    }
  return cutting;
}

int FindPick(xc, yc)
{
   int  i, j, cuts, found, pick;

   i = data.cPoly-1;
   found = 0;
   pick = -1;
   while ((i >= 0) && !found) { 
      cuts = 0;
      for (j=0; j < data.pic[i].size-1; j++)  
         if (cutting(data.pic[i].points[  j].x,
                     data.pic[i].points[  j].y,
                     data.pic[i].points[j+1].x,
                     data.pic[i].points[j+1].y,
                     xc, yc)) cuts++;

      j = data.pic[i].size-1;

      if (cutting(data.pic[i].points[j].x,
                  data.pic[i].points[j].y,
                  data.pic[i].points[0].x,
                  data.pic[i].points[0].y,
                  xc, yc)) cuts++;
      if (cuts%2) {
         found = 1;
         pick = i;
      }
      i = i - 1;
   }
   return pick;
}

void StartMove(w, event)
Widget  w;
XEvent  *event;
{
    pick = FindPick(event->xbutton.x, event->xbutton.y);
    if (pick != -1) {
       data.doingMove = TRUE;
       oldx = event->xbutton.x;
       oldy = event->xbutton.y;
       GrabPointer(); 
       ClearPicture();
       RedrawExcept(pick);
       DrawXorPoly(pick);
    }
}

MoveOk(poly, dx, dy)
int poly, dx, dy;
{
    int i;

    for (i = 0; i < data.pic[poly].size; i++) {
       if (data.pic[poly].points[i].x + dx < 0)
	  return 0;
       if (data.pic[poly].points[i].y + dy < 0)
	  return 0;
       if (data.pic[poly].points[i].x + dx > WIDTH)
	  return 0;
       if (data.pic[poly].points[i].y + dy > HEIGHT)
	  return 0;
    }
    return 1;
}

void MoveMove(w, event)
Widget  w;
XEvent  *event;
{
    int i, dx, dy;

    dx = event->xbutton.x - oldx;
    dy = event->xbutton.y - oldy;
    if (MoveOk(pick, dx, dy)) {
       DrawXorPoly(pick);
       for (i = 0; i < data.pic[pick].size; i++) {
          data.pic[pick].points[i].x += dx;
          data.pic[pick].points[i].y += dy;
       }
       DrawXorPoly(pick);
    }
    oldx = event->xbutton.x;
    oldy = event->xbutton.y;
}

void UpdateMove(w, event)
Widget     w;
XEvent     *event;
{
    int i, dx, dy;

    DrawXorPoly(pick);
    data.doingMove = FALSE;
    dx = event->xbutton.x - oldx;
    dy = event->xbutton.y - oldy;
    for (i = 0; i < data.pic[pick].size; i++) {
       data.pic[pick].points[i].x += dx;
       data.pic[pick].points[i].y += dy;
    }
    DrawPoly(pick);
    UpdateUndo();
    ClearPicture();
    RedrawPicture();
    UngrabPointer();
}
