#include <math.h>
#include "draw.h"

#define MIN_DIST 10

extern drawData  data;

int oldx, oldy;
int pick, point, found, bestDistance;

InitBestPoint()
{
   found = 0;
   bestDistance = (HEIGHT + WIDTH);
}

comparePoint(p1, p2) 
XPoint p1, p2;
{
   int dist;

   dist = (int)sqrt((double)((p1.x-p2.x)*(p1.x-p2.x)
			      + (p1.y-p2.y)*(p1.y-p2.y)));
   if ((dist < bestDistance) && (dist < MIN_DIST)) {
      bestDistance = dist;
      return 1;      
   }
   return 0;
}

int FindBestPoint(x, y)
int x,y;
{
   XPoint pt;
   int  i, j;

   InitBestPoint();
   pt.x = x;
   pt.y = y;
   for (i = data.cPoly-1; i >= 0; i--) 
      for (j=0; j < data.pic[i].size; j++)  
         if (comparePoint(data.pic[i].points[j], pt)) {
	    found = 1;
            pick = i;
	    point = j;
         }
   return found;
}

MovePointOk(poly, point, dx, dy)
int poly, point, dx, dy;
{
   int i;

   if (data.pic[poly].points[point].x + dx < 0)
      return 0;
   if (data.pic[poly].points[point].y + dy < 0)
      return 0;
   if (data.pic[poly].points[point].x + dx > WIDTH)
      return 0;
   if (data.pic[poly].points[point].y + dy > HEIGHT)
      return 0;
   return 1;
}

void StartPointAdjust(w, event)
Widget  w;
XEvent  *event;
{
    int found;

    found = FindBestPoint(event->xbutton.x, event->xbutton.y);
    if (found) {
       data.doingPointAdjust = TRUE;
       oldx = event->xbutton.x;
       oldy = event->xbutton.y;
       GrabPointer(); 
       ClearPicture();
       RedrawExcept(pick);
       DrawXorPoly(pick);
    }
}

void MovePointAdjust(w, event)
Widget  w;
XEvent  *event;
{
    int i, dx, dy;

    dx = event->xbutton.x - oldx;
    dy = event->xbutton.y - oldy;
    if (MovePointOk(pick, point, dx, dy)) {
       DrawXorPoly(pick);
       data.pic[pick].points[point].x += dx;
       data.pic[pick].points[point].y += dy;
       DrawXorPoly(pick);
    }
    oldx = event->xbutton.x;
    oldy = event->xbutton.y;
}

void UpdatePointAdjust(w, event)
Widget     w;
XEvent     *event;
{
    int i, dx, dy;

    DrawXorPoly(pick);
    data.doingPointAdjust = FALSE;
    dx = event->xbutton.x - oldx;
    dy = event->xbutton.y - oldy;
    if (MovePointOk(pick, point, dx, dy)) {
       data.pic[pick].points[point].x += dx;
       data.pic[pick].points[point].y += dy;
    }
    DrawPoly(pick);
    UpdateUndo();
    ClearPicture();
    RedrawPicture();
    UngrabPointer();
}
