#include "draw.h"

extern drawData  data;
extern int       cColor;

void StartRubber(w, event)
Widget  w;
XEvent  *event;
{
    int cPnt;

    if (data.cPoly != MAXDESCSIZE) {
	/* Set drawing GCs to the current color */
	SetGCColor(w, data.dashGc, XOR);
	SetGCColor(w, data.solidXorGc, XOR);
	SetGCColor(w, data.solidGc, COPY);
 
	data.pic[data.cPoly].color = cColor;
	cPnt = data.pic[data.cPoly].size = 0;
	data.doingPoly = TRUE;
	data.last_x  =  data.start_x = event->xbutton.x;
	data.last_y  =  data.start_y = event->xbutton.y;
	data.pic[data.cPoly].points[cPnt].x = data.start_poly_x = data.start_x;
	data.pic[data.cPoly].points[cPnt].y = data.start_poly_y = data.start_y;
	data.pic[data.cPoly].size++; 
	
	XDrawLine(XtDisplay(w), XtWindow(w), 
		  data.dashGc, data.start_x, 
		  data.start_y, data.last_x, data.last_y);
	GrabPointer();
    }
}

void MoveRubber(w, event)
Widget  w;
XEvent  *event;
{
    /* Draw once to clear the previous line. */
    XDrawLine(XtDisplay(w), XtWindow(w), data.dashGc, 
	      data.start_x,data.start_y, 
	      data.last_x, data.last_y);
    
    /* Update the endpoints.  */
    data.last_x  =  event->xbutton.x;
    data.last_y  =  event->xbutton.y;
    
    /* Draw the new line */
    XDrawLine(XtDisplay(w), XtWindow(w), data.dashGc, 
	      data.start_x, data.start_y, 
	      data.last_x, data.last_y);
}

int ValidButtonPress(event)
XEvent     *event;
{
    
    if ((event->xbutton.button == 1) 
	&& (data.pic[data.cPoly].size < MAXPOINTPOLY - 1))
      return 1;
    if ((event->xbutton.button == 3) && (data.pic[data.cPoly].size > 1))
      return 1;
    return 0;
}

void UpdateRubber(w, event)
Widget     w;
XEvent     *event;
{
   int cPnt;
   
   if (ValidButtonPress(event)) {
       /* Clear the current line and update the endpoint info.  */
       XDrawLine(XtDisplay(w), XtWindow(w), data.dashGc, 
		 data.start_x, data.start_y, 
		 data.last_x, data.last_y);
       
       cPnt = data.pic[data.cPoly].size; 
       data.pic[data.cPoly].points[cPnt].x = data.last_x  =  event->xbutton.x;
       data.pic[data.cPoly].points[cPnt].y = data.last_y  =  event->xbutton.y;
       data.pic[data.cPoly].size++; 
       
       /* Draw a solid line.  */
       XDrawLine(XtDisplay(w), XtWindow(w), data.solidXorGc, 
		 data.start_x, data.start_y, 
		 data.last_x, data.last_y);
     
       if (event->xbutton.button == 1) {
	   /* start new rubber line */
	   data.last_x  =  data.start_x = event->xbutton.x;
	   data.last_y  =  data.start_y = event->xbutton.y;
	   XDrawLine(XtDisplay(w), XtWindow(w),
		     data.dashGc, data.start_x,
		     data.start_y, data.last_x, data.last_y);
       }
       if (event->xbutton.button == 3) {
	   /* finish polygon */
	   data.doingPoly = FALSE;
	   DoOutline(data.cPoly);
           DrawPoly(data.cPoly); 

      	   data.cPoly++;
	   UpdateUndo();
	   SetPolyNumLabel();
	   UngrabPointer();
       } 
   } 
}
