#include "draw.h"

extern drawData  data;
extern int       cColor;

void Swap(i, j)
int *i, *j;
{
   int tmp;

   tmp = *i;
   *i = *j;
   *j = tmp;
}

void StartRect(w, event)
Widget  w;
XEvent  *event;
{
   int cPnt;

   if (data.cPoly != MAXDESCSIZE) {
      SetGCColor(w, data.dashGc, XOR);
      SetGCColor(w, data.solidXorGc, XOR);
      SetGCColor(w, data.solidGc, COPY);

      data.pic[data.cPoly].color = cColor;
      cPnt = data.pic[data.cPoly].size = 0;
      data.doingRect = TRUE;
      data.last_x  =  data.start_x = event->xbutton.x;
      data.last_y  =  data.start_y = event->xbutton.y;
      data.pic[data.cPoly].points[cPnt].x = data.start_poly_x  =  data.start_x;
      data.pic[data.cPoly].points[cPnt].y = data.start_poly_y  =  data.start_y;
      data.pic[data.cPoly].size++; 

      XDrawRectangle(XtDisplay(w), XtWindow(w), 
                data.dashGc, data.start_x, 
                data.start_y, data.last_x - data.start_x,
		data.last_y - data.start_y);
      GrabPointer(); 
   }
}

void MoveRect(w, event)
Widget  w;
XEvent  *event;
{
  /* Draw once to clear the previous rect. */
  XDrawRectangle(XtDisplay(w), XtWindow(w), data.dashGc, 
            data.start_x,data.start_y, 
            data.last_x-data.start_x, data.last_y-data.start_y);

  /* Update the endpoints. */
  data.last_x  =  event->xbutton.x;
  data.last_y  =  event->xbutton.y;

  if (data.last_x < data.start_x) 
     data.last_x = data.start_x;
  if (data.last_y < data.start_y) 
     data.last_y = data.start_y;

  /* Draw the new rect */
  XDrawRectangle(XtDisplay(w), XtWindow(w), data.dashGc, 
                 data.start_x, data.start_y, 
                 data.last_x-data.start_x, data.last_y-data.start_y);
}


void UpdateRect(w, event)
Widget     w;
XEvent     *event;
{
   int cPnt;

   if (ValidButtonPress(event)) {
      /* Clear the current line and update the endpoint info.  */
      XDrawRectangle(XtDisplay(w), XtWindow(w), data.dashGc, 
               data.start_x, data.start_y, 
               data.last_x-data.start_x, data.last_y-data.start_y);

      cPnt = data.pic[data.cPoly].size;
      data.pic[data.cPoly].points[cPnt].x = data.start_x;
      data.pic[data.cPoly].points[cPnt].y = event->xbutton.y;
      cPnt++;
      data.pic[data.cPoly].points[cPnt].x = data.last_x  =  event->xbutton.x;
      data.pic[data.cPoly].points[cPnt].y = data.last_y  =  event->xbutton.y;
      cPnt++;
      data.pic[data.cPoly].points[cPnt].x = event->xbutton.x;
      data.pic[data.cPoly].points[cPnt].y = data.start_y;
      cPnt++;
      data.pic[data.cPoly].size = cPnt; 

      data.doingRect = FALSE;
      DrawPoly(data.cPoly);

      data.cPoly++;
      UpdateUndo();
      SetPolyNumLabel();
      UngrabPointer(); 
   } 
}
